﻿namespace TestProject
{
    /// <summary>
    /// 사람 (확장)
    /// </summary>
    public class PersonExtended : Person
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 카운터
        /// </summary>
        private static int _counter = 1;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ID
        /// </summary>
        private int id;

        /// <summary>
        /// 부모 ID
        /// </summary>
        private int parentID;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ID - ID

        /// <summary>
        /// ID
        /// </summary>
        public int ID
        {
            get
            {
                return this.id;
            }
            set
            {
                this.id = value;
            }
        }

        #endregion
        #region 부모 ID - ParentID

        /// <summary>
        /// 부모 ID
        /// </summary>
        public int ParentID
        {
            get
            {
                return this.parentID;
            }
            set
            {
                this.parentID = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - PersonExtended()

        /// <summary>
        /// 생성자
        /// </summary>
        public PersonExtended()
        {
        }

        #endregion
        #region 생성자 - PersonExtended(firstName, lastName, country, parentID)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="firstName">이름</param>
        /// <param name="lastName">성</param>
        /// <param name="country">국가</param>
        /// <param name="parentID">부모 ID</param>
        public PersonExtended(string firstName, string lastName, string country, int parentID) : base(firstName, lastName, country)
        {
            this.id       = _counter++;
            this.parentID = parentID;
        }

        #endregion
        #region 생성자 - PersonExtended(person, parentID)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="person">사람</param>
        /// <param name="parentID">부모 ID</param>
        public PersonExtended(Person person, int parentID) : this(person.FirstName, person.LastName, person.Country, parentID)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 배열 구하기 - ToArray()

        /// <summary>
        /// 배열 구하기
        /// </summary>
        /// <returns>배열</returns>
        public object[] ToArray()
        {
            return new object[] { ID, ParentID, FirstName, LastName, Country };
        }

        #endregion
    }
}